<template>
  <div
    :id="id"
    class="ob-checkbox-container checkbox-wrapper"
    :class="{ 'disabled': disabled, [type]: type }"
  >
    <label>
      <div class="left-col">
        <input
          data-attr="ob-checkbox-container"
          type="checkbox"
          :disabled="disabled"
          :checked="value"
          :tabindex="disabled ? -1 : 0"
          :data-qa="dataQa"
          @change="$emit('change', $event.target.checked)"
        >
        <div class="input-visual" />
      </div>
      <div
        v-if="label || $slots.label"
        class="right-col"
      >
        <template v-if="$slots.label">
          <slot name="label" />
        </template>
        <template v-else>
          <span
            class="label-text"
            :class="value && '--checked'"
          >
            {{ label + (required ? '*' : '') }}
          </span>
        </template>
      </div>
    </label>
  </div>
</template>
<script>
import UniqueIdMixin from '../../mixins/unique-id'

export default {
  name: 'ObCheckbox',
  mixins: [
    UniqueIdMixin
  ],
  model: {
    event: 'change'
  },
  props: {
    value: {
      type: Boolean,
      default: false
    },
    label: {
      type: String,
      default: null
    },
    disabled: {
      type: Boolean,
      default: () => false
    },
    type: {
      type: String,
      default: () => 'default'
    },
    required: {
      type: Boolean
    },
    dataQa: {
      type: String
    }
  }
}
</script>
<style lang="scss" scoped>
  $transition-timing: .2s cubic-bezier(.645,.045,.355,1);
  $primary: $color-blue-navy-blue;
  $primary-hover: $lavender;
  $border: $color-grey-span;
  $border-disabled: $color-grey-border;
  $text: $gray-slate;
  $text-checked: $color-text-base;
  $text-disabled: $color-grey-span;
  $bg-disabled: $color-white-lilac;

  .ob-checkbox-container {
    &.checkbox-wrapper {
      user-select: none;
      -webkit-user-select: none;

      &.default {
        input:checked + .input-visual {
          background-color: $primary;
          background-image: url("data:image/svg+xml;base64,PHN2ZyB3aWR0aD0iOSIgaGVpZ2h0PSI3IiB2aWV3Qm94PSIwIDAgOSA3IiBmaWxsPSJub25lIiB4bWxucz0iaHR0cDovL3d3dy53My5vcmcvMjAwMC9zdmciPgo8cGF0aCBkPSJNMSAzLjVMMy4zNDg0NCA2TDcuNSAxIiBzdHJva2U9IndoaXRlIiBzdHJva2Utd2lkdGg9IjIiIHN0cm9rZS1saW5lY2FwPSJyb3VuZCIgc3Ryb2tlLWxpbmVqb2luPSJyb3VuZCIvPgo8L3N2Zz4K");
          border-color: $primary;
        }
      }

      &.particular {
        .input-visual {
          &::after {
            content: '';
            position: absolute;
            top: 0;
            left: 0;
            right: 0;
            bottom: 0;
            margin: auto;
            width: 6px;
            height: 2px;
          }
        }
        input:checked + .input-visual {
          border-color: $primary;

          &::after {
            background-color: $primary;
            opacity: 1;
          }
        }
      }

      &.square {
        .input-visual {
          &::after {
            content: '';
            position: absolute;
            top: 0;
            left: 0;
            right: 0;
            bottom: 0;
            margin: auto;
            width: 6px;
            height: 6px;
          }
        }
        input:checked + .input-visual {
          border-color: $primary;

          &::after {
            background-color: $primary;
            opacity: 1;
          }
        }
      }

      &.disabled {
        pointer-events: none;

        .right-col {
          span {
            color: $text-disabled
          }
        }

        .left-col {
          input:checked + .input-visual {
            background-color: $border-disabled;
            border-color: $border-disabled;
          }

          .input-visual {
            border-color: $border-disabled;
            background-color: $bg-disabled;
          }
        }

        &.particular {
          input:checked + .input-visual {
            border-color: $border-disabled;
            background-color: $bg-disabled;

            &::after {
              background: $border-disabled;
            }
          }
        }
      }
    }

    label {
      display: flex;
      align-items: flex-start;
      cursor: pointer;
      transition: $transition-timing;

      &:hover {
        .input-visual {
          background-color: $primary-hover;
          border-color: $primary;
        }
      }
    }

    input {
      margin: 0;
      padding: 0;
      width: 0;
      height: 0;
      opacity: 0;
      background: transparent;
      position: absolute;
      &:focus + .input-visual {
        background-color: $primary-hover;
        border-color: $primary;
      }
    }
    .left-col {
      width: 24px;
      height: 24px;
      display: flex;
      justify-content: center;
      align-items: center;
      flex-shrink: 0;
    }
    .right-col {
      padding-top: 4px;
      font-family: "Roboto", sans-serif;
      margin-left: 5px;
      .label-text {
        font-size: 14px;
        line-height: 16px;
        letter-spacing: 0.2px;
        color: $text;
        &.--checked {
          color: $text-checked;
        }
      }
    }
    .input-visual {
      width: 14px;
      height: 14px;
      box-sizing: border-box;
      border: 2px solid $border;
      border-radius: 2px;
      transition: $transition-timing;
      position: relative;
      background-position: 1px 2px;
      background-repeat: no-repeat;
      background-size: 9px 7px;

      &::after {
        opacity: 0;
        transition: $transition-timing;
      }
    }
  }
</style>
